//******************************************************************************************
//* Lorenz Attractor, by Paul Nylander, bugman123.com, 7/15/07
//******************************************************************************************

camera{location 34*<1,-1,1> look_at <-2,0,26.5> up z right x*image_width/image_height sky <0,0,1>}
light_source{34*<1,-1,1>,1}

#declare rtube=0.25; #declare dt=0.01; #declare sigma=3; #declare rho=26.5; #declare beta=1;
#macro dpdt(p) <sigma*(p.y-p.x),rho*p.x-p.x*p.z-p.y,p.x*p.y-beta*p.z> #end
#declare p1=<0,1,1>; #declare T=0;
#while(T<100)
 #declare k1=dt*dpdt(p1); #declare k2=dt*dpdt(p1+k1/2); #declare k3=dt*dpdt(p1+k2/2); #declare k4=dt*dpdt(p1+k3);
 #declare p2=p1+(k1+2*k2+2*k3+k4)/6; // 4th order Runge-Kutta method
 union{sphere{p2,rtube}
  #if(vlength(p2-p1)>0.001) cylinder{p1,p2,rtube} #end
  pigment{rgb 1} finish{phong 0.8 phong_size 1.5}
 }
 #declare p1=p2; #declare T=T+dt;
#end
